From 82f7aeac8adc77de14b6c6fb0fb76cd4b6adb16e Mon Sep 17 00:00:00 2001
From: Daniel Gustafsson <dgustafsson@postgresql.org>
Date: Fri, 28 Aug 2026 13:28:10 +0200
Subject: [PATCH v1] Revert online data checksums transitions

The feature to enable, or disable, data checksums in an online
cluster saw a number of postcommit fixes during the beta period.
Suspicions were raised about the risk of more issues surfacing
after GA.  To avoid shipping code which may have bugs, this
reverts in full, or in part, the following commits:

aaf8b9989f7, cd857dec0e0, 5fee7cab1b8, 25b922ec582, 8fb8ded8895,
b3a37ffbc5b, abac86c7a27, 3a18526e8d6, 01805b7d16b, 343d98c3601,
e469e4784ea, 8d22f523245, e5e1f6dc795, 5ab239c9a90, 0ca1b301059,
9a39056c418, 2018bd61679, 1df361e3d82, bf25e5571b3, 381d19da153,
b120358c612, 07009121c23, d771b0a907e, f19c0eccae9, 0907112d388,
397f0fd06ed, 602f19c84ca, e3a27cad462, 4ae3e98c02c, b364828f825

A few bits remain as they have merit on their own:
* The fix for offline checksums not preserving initial state in
  pg_control_init.  The test case for this fix has been moved to
  src/bin/pg_checksums/t/002_actions.pl to survive the revert
  which removed the previous location.
* When a page verification is logged, the additional note which
  informs if the buffer will be zeroed out was kept to aid any
  debugging around checksum failures.
* The Data Checksum section in the docs was kept, but rewritten
  to reflect the current state.
* The enum containing checksum states is kept and some hardcoded
  references to the off state (0) are replaced with the label
  PG_DATA_CHECKSUM_OFF instead.

Discussion: https://postgr.es/m/anwm6UPxoVS41QA2@bdtpg
Discussion: https://postgr.es/m/CA+Tgmob9NY6m0YNFTQ4nFH2d0iC9SQRruDYxfndGKKzh8OC80w@mail.gmail.com
Discussion: https://postgr.es/m/E07A611B-9CF3-4FDB-8CE8-A221E39040EC%40yesql.se
---
 doc/src/sgml/config.sgml                      |    5 +-
 doc/src/sgml/func/func-admin.sgml             |   79 -
 doc/src/sgml/func/func-info.sgml              |    5 -
 doc/src/sgml/glossary.sgml                    |   20 +-
 doc/src/sgml/images/Makefile                  |    1 -
 doc/src/sgml/images/datachecksums.gv          |   14 -
 doc/src/sgml/images/datachecksums.svg         |   81 -
 doc/src/sgml/monitoring.sgml                  |  228 +-
 doc/src/sgml/ref/pg_basebackup.sgml           |    6 -
 doc/src/sgml/ref/pg_checksums.sgml            |   12 +-
 doc/src/sgml/regress.sgml                     |   14 -
 doc/src/sgml/release-19.sgml                  |   26 -
 doc/src/sgml/wal.sgml                         |  185 +-
 src/backend/access/rmgrdesc/xlogdesc.c        |   58 +-
 src/backend/access/transam/xlog.c             |  553 +----
 src/backend/backup/basebackup.c               |   90 +-
 src/backend/catalog/system_views.sql          |   19 -
 src/backend/commands/dbcommands.c             |   34 -
 src/backend/postmaster/Makefile               |    1 -
 src/backend/postmaster/auxprocess.c           |   28 -
 src/backend/postmaster/bgworker.c             |    9 -
 src/backend/postmaster/datachecksum_state.c   | 1979 -----------------
 src/backend/postmaster/meson.build            |    1 -
 src/backend/postmaster/postmaster.c           |    5 -
 src/backend/replication/logical/decode.c      |   16 -
 src/backend/storage/ipc/procsignal.c          |    8 -
 src/backend/storage/page/README               |    4 +-
 src/backend/storage/page/bufpage.c            |   18 +-
 src/backend/utils/activity/pgstat_backend.c   |    2 -
 src/backend/utils/activity/pgstat_io.c        |   35 -
 .../utils/activity/wait_event_names.txt       |    3 -
 src/backend/utils/adt/pgstatfuncs.c           |    8 +-
 src/backend/utils/init/miscinit.c             |    3 +-
 src/backend/utils/init/postinit.c             |   30 +-
 src/backend/utils/misc/guc_parameters.dat     |    6 +-
 src/backend/utils/misc/guc_tables.c           |    9 +-
 src/backend/utils/misc/pg_controldata.c       |    9 +-
 src/backend/utils/misc/postgresql.conf.sample |   10 +-
 src/bin/pg_checksums/t/002_actions.pl         |    5 +
 src/bin/pg_controldata/pg_controldata.c       |    2 -
 src/bin/pg_upgrade/controldata.c              |    9 -
 src/bin/pg_waldump/t/001_basic.pl             |    3 +-
 src/include/access/rmgrlist.h                 |    1 -
 src/include/access/xlog.h                     |   20 +-
 src/include/access/xlog_internal.h            |    6 -
 src/include/catalog/pg_control.h              |    7 -
 src/include/catalog/pg_proc.dat               |   12 -
 src/include/commands/progress.h               |   16 -
 src/include/miscadmin.h                       |   10 -
 src/include/postmaster/datachecksum_state.h   |   28 -
 src/include/postmaster/proctypelist.h         |    2 -
 src/include/replication/decode.h              |    1 -
 src/include/storage/checksum.h                |   13 +-
 src/include/storage/lwlocklist.h              |    1 -
 src/include/storage/procsignal.h              |    4 -
 src/include/storage/subsystemlist.h           |    1 -
 src/include/utils/backend_progress.h          |    1 -
 src/test/modules/Makefile                     |    1 -
 src/test/modules/meson.build                  |    1 -
 src/test/modules/test_checksums/.gitignore    |    2 -
 src/test/modules/test_checksums/Makefile      |   36 -
 src/test/modules/test_checksums/README        |   30 -
 src/test/modules/test_checksums/meson.build   |   40 -
 .../modules/test_checksums/t/001_basic.pl     |  221 --
 .../modules/test_checksums/t/002_restarts.pl  |  160 --
 .../test_checksums/t/003_standby_restarts.pl  |  288 ---
 .../modules/test_checksums/t/004_offline.pl   |  108 -
 .../modules/test_checksums/t/005_injection.pl |  215 --
 .../test_checksums/t/006_pgbench_single.pl    |  285 ---
 .../test_checksums/t/007_pgbench_standby.pl   |  411 ----
 src/test/modules/test_checksums/t/008_pitr.pl |  192 --
 src/test/modules/test_checksums/t/009_fpi.pl  |   64 -
 .../test_checksums/t/010_backup_straddle.pl   |  260 ---
 .../test_checksums/t/011_standby_straddle.pl  |  249 ---
 .../test_checksums/t/DataChecksums/Utils.pm   |  243 --
 .../test_checksums/test_checksums--1.0.sql    |   16 -
 .../modules/test_checksums/test_checksums.c   |  105 -
 .../test_checksums/test_checksums.control     |    4 -
 src/test/regress/expected/rules.out           |   38 -
 src/test/regress/expected/stats.out           |   11 +-
 src/tools/pgindent/typedefs.list              |    6 -
 81 files changed, 79 insertions(+), 6663 deletions(-)
 delete mode 100644 doc/src/sgml/images/datachecksums.gv
 delete mode 100644 doc/src/sgml/images/datachecksums.svg
 delete mode 100644 src/backend/postmaster/datachecksum_state.c
 delete mode 100644 src/include/postmaster/datachecksum_state.h
 delete mode 100644 src/test/modules/test_checksums/.gitignore
 delete mode 100644 src/test/modules/test_checksums/Makefile
 delete mode 100644 src/test/modules/test_checksums/README
 delete mode 100644 src/test/modules/test_checksums/meson.build
 delete mode 100644 src/test/modules/test_checksums/t/001_basic.pl
 delete mode 100644 src/test/modules/test_checksums/t/002_restarts.pl
 delete mode 100644 src/test/modules/test_checksums/t/003_standby_restarts.pl
 delete mode 100644 src/test/modules/test_checksums/t/004_offline.pl
 delete mode 100644 src/test/modules/test_checksums/t/005_injection.pl
 delete mode 100644 src/test/modules/test_checksums/t/006_pgbench_single.pl
 delete mode 100644 src/test/modules/test_checksums/t/007_pgbench_standby.pl
 delete mode 100644 src/test/modules/test_checksums/t/008_pitr.pl
 delete mode 100644 src/test/modules/test_checksums/t/009_fpi.pl
 delete mode 100644 src/test/modules/test_checksums/t/010_backup_straddle.pl
 delete mode 100644 src/test/modules/test_checksums/t/011_standby_straddle.pl
 delete mode 100644 src/test/modules/test_checksums/t/DataChecksums/Utils.pm
 delete mode 100644 src/test/modules/test_checksums/test_checksums--1.0.sql
 delete mode 100644 src/test/modules/test_checksums/test_checksums.c
 delete mode 100644 src/test/modules/test_checksums/test_checksums.control

diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index 97aeadfc35f..afb8651f07b 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -7498,7 +7498,6 @@ local0.*    /var/log/postgresql
          <member><literal>bgworker</literal></member>
          <member><literal>bgwriter</literal></member>
          <member><literal>checkpointer</literal></member>
-         <member><literal>checksums</literal></member>
          <member><literal>ioworker</literal></member>
          <member><literal>postmaster</literal></member>
          <member><literal>slotsyncworker</literal></member>
@@ -12305,7 +12304,7 @@ dynamic_library_path = '/usr/local/lib/postgresql:$libdir'
      </varlistentry>
 
      <varlistentry id="guc-data-checksums" xreflabel="data_checksums">
-      <term><varname>data_checksums</varname> (<type>enum</type>)
+      <term><varname>data_checksums</varname> (<type>bool</type>)
       <indexterm>
        <primary><varname>data_checksums</varname> configuration parameter</primary>
       </indexterm>
@@ -12313,8 +12312,6 @@ dynamic_library_path = '/usr/local/lib/postgresql:$libdir'
       <listitem>
        <para>
         Reports the state of data checksums for this cluster.
-        Possible values are <literal>on</literal>, <literal>off</literal>,
-        <literal>inprogress-on</literal> and <literal>inprogress-off</literal>.
         See <xref linkend="checksums"/> for more information.
        </para>
       </listitem>
diff --git a/doc/src/sgml/func/func-admin.sgml b/doc/src/sgml/func/func-admin.sgml
index 0eae1c1f616..ff860363f3f 100644
--- a/doc/src/sgml/func/func-admin.sgml
+++ b/doc/src/sgml/func/func-admin.sgml
@@ -3122,83 +3122,4 @@ SELECT convert_from(pg_read_binary_file('file_in_utf8.txt'), 'UTF8');
    </table>
 
   </sect2>
-
-  <sect2 id="functions-admin-checksum">
-   <title>Data Checksum Functions</title>
-
-   <para>
-    The functions shown in <xref linkend="functions-checksums-table" /> can
-    be used to enable or disable data checksums in a running cluster.
-   </para>
-   <para>
-    Changing data checksums can be done in a cluster with concurrent activity
-    without blocking queries, but overall system performance will be affected.
-    See <xref linkend="checksums" /> for further details on how changing the
-    data checksums state can affect a system and possible mitigations for how
-    to reduce the impact.
-   </para>
-
-   <table id="functions-checksums-table">
-    <title>Data Checksum Functions</title>
-    <tgroup cols="1">
-     <thead>
-      <row>
-       <entry role="func_table_entry"><para role="func_signature">
-        Function
-       </para>
-       <para>
-        Description
-       </para></entry>
-      </row>
-     </thead>
-
-     <tbody>
-      <row>
-       <entry role="func_table_entry"><para role="func_signature">
-        <indexterm>
-         <primary>pg_enable_data_checksums</primary>
-        </indexterm>
-        <function>pg_enable_data_checksums</function> ( <optional><parameter>cost_delay</parameter> <type>int</type>, <parameter>cost_limit</parameter> <type>int</type></optional> )
-        <returnvalue>void</returnvalue>
-       </para>
-       <para>
-        Initiates the process of enabling data checksums for the cluster. This
-        will set the data checksums state to <literal>inprogress-on</literal>
-        as well as start a background worker that will process all pages in all
-        databases and enable data checksums on them.  When all pages have
-        been processed, the cluster will automatically set data checksums state
-        to <literal>on</literal>.  This operation is WAL logged and replicated
-        to all standby nodes.
-       </para>
-       <para>
-        If <parameter>cost_delay</parameter> and <parameter>cost_limit</parameter> are
-        specified, the process is throttled using the same principles as
-        <link linkend="runtime-config-resource-vacuum-cost">Cost-based Vacuum Delay</link>.
-       </para>
-       </entry>
-      </row>
-
-      <row>
-       <entry role="func_table_entry"><para role="func_signature">
-        <indexterm>
-         <primary>pg_disable_data_checksums</primary>
-        </indexterm>
-        <function>pg_disable_data_checksums</function> ()
-        <returnvalue>void</returnvalue>
-       </para>
-       <para>
-        Disables data checksum calculation and validation for the cluster. This
-        will set the data checksum state to <literal>inprogress-off</literal>
-        while data checksums are being disabled.  When all active backends have
-        stopped validating data checksums, the data checksum state will be
-        set to <literal>off</literal>.
-       </para>
-       </entry>
-      </row>
-     </tbody>
-    </tgroup>
-   </table>
-
-  </sect2>
-
   </sect1>
diff --git a/doc/src/sgml/func/func-info.sgml b/doc/src/sgml/func/func-info.sgml
index 2f03766b67a..713c837fc02 100644
--- a/doc/src/sgml/func/func-info.sgml
+++ b/doc/src/sgml/func/func-info.sgml
@@ -3496,11 +3496,6 @@ acl      | {postgres=arwdDxtm/postgres,foo=r/postgres}
        <entry><type>xid</type></entry>
       </row>
 
-      <row>
-       <entry><structfield>data_page_checksum_version</structfield></entry>
-       <entry><type>integer</type></entry>
-      </row>
-
       <row>
        <entry><structfield>checkpoint_time</structfield></entry>
        <entry><type>timestamp with time zone</type></entry>
diff --git a/doc/src/sgml/glossary.sgml b/doc/src/sgml/glossary.sgml
index b9a3cb83bc2..899fa4299e2 100644
--- a/doc/src/sgml/glossary.sgml
+++ b/doc/src/sgml/glossary.sgml
@@ -234,9 +234,8 @@
      which runs system- or user-supplied code.
      Serves as infrastructure for several features in
      <productname>PostgreSQL</productname>, such as
-     <glossterm linkend="glossary-replication">logical replication</glossterm>,
-     <glossterm linkend="glossary-parallel-query">parallel queries</glossterm> and
-     <glossterm linkend="glossary-data-checksums-process">data checksums processing</glossterm>.
+     <glossterm linkend="glossary-replication">logical replication</glossterm> and
+     <glossterm linkend="glossary-parallel-query">parallel queries</glossterm>.
      In addition, <glossterm linkend="glossary-extension">Extensions</glossterm> can add
      custom background worker processes.
    </para>
@@ -575,21 +574,6 @@
    <glosssee otherterm="glossary-data-directory" />
   </glossentry>
 
-  <glossentry id="glossary-data-checksums-process">
-   <glossterm>Data Checksums (process)</glossterm>
-   <glossdef>
-    <para>
-     A set of
-     <glossterm linkend="glossary-background-worker">background worker</glossterm>
-     processes which can enable or disable data checksums in a running cluster.
-     The process which coordinates the work is known as the
-     <firstterm>data checksums launcher</firstterm> and the process which
-     operates on the individual databases is known as the
-     <firstterm>data checksums worker</firstterm>.
-    </para>
-   </glossdef>
-  </glossentry>
-
   <glossentry id="glossary-database">
    <glossterm>Database</glossterm>
    <glossdef>
diff --git a/doc/src/sgml/images/Makefile b/doc/src/sgml/images/Makefile
index 9362c30998e..157c1ff366a 100644
--- a/doc/src/sgml/images/Makefile
+++ b/doc/src/sgml/images/Makefile
@@ -3,7 +3,6 @@
 # see README in this directory about image handling
 
 ALL_IMAGES = \
-	datachecksums.svg \
 	genetic-algorithm.svg \
 	gin.svg \
 	pagelayout.svg \
diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index 66f6127a410..ef13f07e7eb 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -436,15 +436,6 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
       </entry>
      </row>
 
-     <row>
-      <entry><structname>pg_stat_progress_data_checksums</structname><indexterm><primary>pg_stat_progress_data_checksums</primary></indexterm></entry>
-      <entry>One row for the data checksum launcher process while data
-       checksums are being enabled or disabled.  When enabling data
-       checksums, the view also has one row for each worker process,
-       showing current progress.
-       See <xref linkend="data-checksum-progress-reporting"/>.
-      </entry>
-     </row>
     </tbody>
    </tgroup>
   </table>
@@ -6140,10 +6131,10 @@ FROM pg_stat_get_backend_idset() AS backendid;
    which support progress reporting are <command>ANALYZE</command>,
    <command>COPY</command>, <command>CREATE INDEX</command>,
    <command>REPACK</command> (and its obsolete spelling <command>CLUSTER</command>),
-   <command>VACUUM</command>,
+   <command>VACUUM</command> and
    <xref linkend="protocol-replication-base-backup"/> (i.e., replication
    command that <xref linkend="app-pgbasebackup"/> issues to take
-   a base backup), and online data checksum operations.
+   a base backup).
    This may be expanded in the future.
   </para>
 
@@ -7870,221 +7861,6 @@ FROM pg_stat_get_backend_idset() AS backendid;
   </table>
 
  </sect2>
-
- <sect2 id="data-checksum-progress-reporting">
-  <title>Data Checksum Progress Reporting</title>
-
-  <indexterm>
-   <primary>pg_stat_progress_data_checksums</primary>
-  </indexterm>
-
-  <para>
-   When data checksums are being enabled or disabled on a running cluster, the
-   <structname>pg_stat_progress_data_checksums</structname> view will contain
-   a row for the launcher process.  When enabling data checksums, the view
-   will also contain one row for each worker process which is currently
-   calculating and writing checksums for the data pages in a database.  The
-   launcher provides an overview of the overall progress, such as how many
-   databases have been processed and how many remain, while the workers track
-   progress for currently processed databases.
-  </para>
-
-  <table id="pg-stat-progress-data-checksums-view" xreflabel="pg_stat_progress_data_checksums">
-   <title><structname>pg_stat_progress_data_checksums</structname> View</title>
-   <tgroup cols="1">
-    <thead>
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        Column Type
-       </para>
-       <para>
-        Description
-       </para>
-      </entry>
-     </row>
-    </thead>
-
-    <tbody>
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>pid</structfield> <type>integer</type>
-       </para>
-       <para>
-        Process ID of the data checksum process, launcher or worker.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>datid</structfield> <type>oid</type>
-       </para>
-       <para>
-        OID of this database, or <literal>0</literal> for the launcher process.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>datname</structfield> <type>name</type>
-       </para>
-       <para>
-        Name of this database, or <literal>NULL</literal> for the
-        launcher process.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>phase</structfield> <type>text</type>
-       </para>
-       <para>
-        Current processing phase, see <xref linkend="datachecksum-phases"/>
-        for description of the phases.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>databases_total</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The total number of databases which will be processed. Only the
-        launcher process has this value set when enabling data checksums;
-        otherwise this is set to <literal>NULL</literal>.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>databases_done</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The number of databases which have been processed. Only the launcher
-        process has this value set when enabling data checksums; otherwise
-        this is set to <literal>NULL</literal>.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>relations_total</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The total number of relations which will be processed, or
-        <literal>NULL</literal> if the worker process hasn't
-        calculated the number of relations yet. The launcher process has
-        this set to <literal>NULL</literal> since it isn't responsible for
-        processing relations, only launching worker processes.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>relations_done</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The number of relations which have been processed. The launcher
-        process has this set to <literal>NULL</literal>.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>blocks_total</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The number of blocks in the current relation which will be processed,
-        or <literal>NULL</literal> if the worker process hasn't
-        calculated the number of blocks yet. The launcher process has
-        this set to <literal>NULL</literal>.
-       </para>
-      </entry>
-     </row>
-
-     <row>
-      <entry role="catalog_table_entry">
-       <para role="column_definition">
-        <structfield>blocks_done</structfield> <type>bigint</type>
-       </para>
-       <para>
-        The number of blocks in the current relation which have been processed.
-        The launcher process has this set to <literal>NULL</literal>.
-       </para>
-      </entry>
-     </row>
-
-    </tbody>
-   </tgroup>
-  </table>
-
-  <table id="datachecksum-phases">
-   <title>Data Checksum Phases</title>
-   <tgroup cols="2">
-    <colspec colname="col1" colwidth="1*"/>
-    <colspec colname="col2" colwidth="2*"/>
-    <thead>
-     <row>
-      <entry>Phase</entry>
-      <entry>Description</entry>
-     </row>
-    </thead>
-    <tbody>
-     <row>
-      <entry><literal>enabling</literal></entry>
-      <entry>
-       The command is currently enabling data checksums on the cluster.
-      </entry>
-     </row>
-     <row>
-      <entry><literal>disabling</literal></entry>
-      <entry>
-       The command is currently disabling data checksums on the cluster.
-      </entry>
-     </row>
-     <row>
-      <entry><literal>done</literal></entry>
-      <entry>
-       The command is done and the data checksum state in the cluster has
-       changed.
-      </entry>
-     </row>
-     <row>
-      <entry><literal>waiting on barrier</literal></entry>
-      <entry>
-       The command is currently waiting for the current active backends to
-       acknowledge the change in data checksum state.
-      </entry>
-     </row>
-     <row>
-      <entry><literal>waiting on temporary tables</literal></entry>
-      <entry>
-       The command is currently waiting for all temporary tables which existed
-       at the time the command was started to be removed.
-      </entry>
-     </row>
-    </tbody>
-   </tgroup>
-  </table>
- </sect2>
-
  </sect1>
 
  <sect1 id="dynamic-trace">
diff --git a/doc/src/sgml/ref/pg_basebackup.sgml b/doc/src/sgml/ref/pg_basebackup.sgml
index 3117968d125..fecee08b0a5 100644
--- a/doc/src/sgml/ref/pg_basebackup.sgml
+++ b/doc/src/sgml/ref/pg_basebackup.sgml
@@ -788,12 +788,6 @@ PostgreSQL documentation
         in the <link linkend="monitoring-pg-stat-database-view">
         <structname>pg_stat_database</structname></link> view.
        </para>
-       <para>
-        Checksums must be enabled on the server for the duration of the base
-        backup in order to be verified.  If checksums are in the process of
-        being enabled when the base backup starts then checksum verification is
-        disabled for the base backup.
-       </para>
       </listitem>
      </varlistentry>
     </variablelist>
diff --git a/doc/src/sgml/ref/pg_checksums.sgml b/doc/src/sgml/ref/pg_checksums.sgml
index ae66fad3f0f..fcded6b4a05 100644
--- a/doc/src/sgml/ref/pg_checksums.sgml
+++ b/doc/src/sgml/ref/pg_checksums.sgml
@@ -39,23 +39,13 @@ PostgreSQL documentation
    <application>pg_checksums</application> checks, enables or disables data
    checksums in a <productname>PostgreSQL</productname> cluster.  The server
    must be shut down cleanly before running <application>pg_checksums</application>.
-   Checksums can also be enabled while the cluster is running using
-   <xref linkend="checksums-online-enable-disable"/> processing, see
-   <xref linkend="checksums"/> for further details on the different approaches.
+   See <xref linkend="checksums"/> for further details on data checksums.
    When verifying checksums, the exit
    status is zero if there are no checksum errors, and nonzero if at least one
    checksum failure is detected. When enabling or disabling checksums, the
    exit status is nonzero if the operation failed.
   </para>
 
-  <para>
-   When enabling checksums with <application>pg_checksums</application>, if
-   checksums were in the process of being enabled using
-   <xref linkend="checksums-online-enable-disable"/>  when the cluster was shut
-   down, <application>pg_checksums</application> will still process all
-   relation files regardless of the progress of online checksum processing.
-  </para>
-
   <para>
    When verifying checksums, every file in the cluster is scanned. When
    enabling checksums, each relation file block with a changed checksum is
diff --git a/doc/src/sgml/regress.sgml b/doc/src/sgml/regress.sgml
index c74941bfbf2..873387ec168 100644
--- a/doc/src/sgml/regress.sgml
+++ b/doc/src/sgml/regress.sgml
@@ -275,20 +275,6 @@ make check-world PG_TEST_EXTRA='kerberos ldap ssl load_balance libpq_encryption'
 </programlisting>
    The following values are currently supported:
    <variablelist>
-    <varlistentry>
-     <term><literal>checksum</literal>, <literal>checksum_extended</literal></term>
-     <listitem>
-      <para>
-       Runs additional tests for enabling data checksums which inject faults
-       to cause re-tries in the processing, as well as tests that run pgbench
-       concurrently and randomly restarts the cluster.  Some of these test
-       suites require injection points enabled in the installation.
-       <literal>checksum_extended</literal> is an extended version with
-       longer runtime, injected random delays and larger datasets.
-      </para>
-     </listitem>
-    </varlistentry>
-
     <varlistentry>
      <term><literal>kerberos</literal></term>
      <listitem>
diff --git a/doc/src/sgml/release-19.sgml b/doc/src/sgml/release-19.sgml
index a8046ab41f0..bb8faed8c18 100644
--- a/doc/src/sgml/release-19.sgml
+++ b/doc/src/sgml/release-19.sgml
@@ -55,13 +55,6 @@
      </para>
     </listitem>
 
-    <listitem>
-     <para>
-      Data checksums can now be
-      <link linkend="checksums-online-enable-disable">enabled or disabled while the database server is running</link>.
-     </para>
-    </listitem>
-
     <listitem>
      <para>
       A new <link linkend="sql-wait-for"><command>WAIT FOR</command></link>
@@ -1391,25 +1384,6 @@ The previous warning was 40 million.  Warnings are issued to clients and in the
      <title>Server Configuration</title>
 
      <itemizedlist>
-<!--
-Author: Daniel Gustafsson <dgustafsson@postgresql.org>
-2026-04-03 [f19c0ecca] Online enabling and disabling of data checksums
-Author: Daniel Gustafsson <dgustafsson@postgresql.org>
-2026-04-08 [b364828f8] doc: Fix data_checksums data type
--->
-
-<listitem>
-<para>
-Allow <link linkend="functions-admin-checksum">online enabling</link> and disabling of <link linkend="checksums">data checksums</link> (Daniel Gustafsson, Magnus Hagander, Tomas Vondra)
-<ulink url="&commit_baseurl;f19c0ecca">&sect;</ulink>
-<ulink url="&commit_baseurl;b364828f8">&sect;</ulink>
-</para>
-
-<para>
-Previously the checksum status could only be changed while the cluster was offline using <link linkend="app-pgchecksums"><application>pg_checksums</application></link>.
-</para>
-</listitem>
-
 <!--
 Author: Nathan Bossart <nathan@postgresql.org>
 2026-03-27 [d7965d65f] Add rudimentary table prioritization to autovacuum.
